{
  This file was automatically generated on 2021-05-06.

  Delphi/Lazarus Bindings Version 2.1.31

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletRotaryEncoderV2;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_ROTARY_ENCODER_V2_DEVICE_IDENTIFIER = 294;
  BRICKLET_ROTARY_ENCODER_V2_DEVICE_DISPLAY_NAME = 'Rotary Encoder Bricklet 2.0';

  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_COUNT = 1;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_COUNT_CALLBACK_CONFIGURATION = 2;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_COUNT_CALLBACK_CONFIGURATION = 3;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_IS_PRESSED = 5;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_RESET = 243;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_WRITE_UID = 248;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_READ_UID = 249;
  BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_ROTARY_ENCODER_V2_CALLBACK_COUNT = 4;
  BRICKLET_ROTARY_ENCODER_V2_CALLBACK_PRESSED = 6;
  BRICKLET_ROTARY_ENCODER_V2_CALLBACK_RELEASED = 7;

  BRICKLET_ROTARY_ENCODER_V2_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_ROTARY_ENCODER_V2_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_ROTARY_ENCODER_V2_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_ROTARY_ENCODER_V2_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_ROTARY_ENCODER_V2_THRESHOLD_OPTION_GREATER = '>';
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_ROTARY_ENCODER_V2_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_ROTARY_ENCODER_V2_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_ROTARY_ENCODER_V2_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_ROTARY_ENCODER_V2_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_ROTARY_ENCODER_V2_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;

  TBrickletRotaryEncoderV2 = class;
  TBrickletRotaryEncoderV2NotifyCount = procedure(sender: TBrickletRotaryEncoderV2; const count: longint) of object;
  TBrickletRotaryEncoderV2NotifyPressed = procedure(sender: TBrickletRotaryEncoderV2) of object;
  TBrickletRotaryEncoderV2NotifyReleased = procedure(sender: TBrickletRotaryEncoderV2) of object;

  /// <summary>
  ///  360° rotary encoder with push-button
  /// </summary>
  TBrickletRotaryEncoderV2 = class(TDevice)
  private
    countCallback: TBrickletRotaryEncoderV2NotifyCount;
    pressedCallback: TBrickletRotaryEncoderV2NotifyPressed;
    releasedCallback: TBrickletRotaryEncoderV2NotifyReleased;
  protected
    procedure CallbackWrapperCount(const packet: TByteArray); virtual;
    procedure CallbackWrapperPressed(const packet: TByteArray); virtual;
    procedure CallbackWrapperReleased(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the current count of the encoder. If you set reset
    ///  to true, the count is set back to 0 directly after the
    ///  current count is read.
    ///  
    ///  The encoder has 24 steps per rotation.
    ///  
    ///  Turning the encoder to the left decrements the counter,
    ///  so a negative count is possible.
    ///  
    ///  
    ///  If you want to get the value periodically, it is recommended to use the
    ///  <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.OnCount"/> callback. You can set the callback configuration
    ///  with <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.SetCountCallbackConfiguration"/>.
    /// </summary>
    function GetCount(const reset: boolean): longint; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.OnCount"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change
    ///  within the period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    ///  
    ///  It is furthermore possible to constrain the callback with thresholds.
    ///  
    ///  The `option`-parameter together with min/max sets a threshold for the <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.OnCount"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Threshold is turned off"
    ///   "'o'",    "Threshold is triggered when the value is *outside* the min and max values"
    ///   "'i'",    "Threshold is triggered when the value is *inside* or equal to the min and max values"
    ///   "'&lt;'",    "Threshold is triggered when the value is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Threshold is triggered when the value is greater than the min value (max is ignored)"
    ///  </code>
    ///  
    ///  If the option is set to 'x' (threshold turned off) the callback is triggered with the fixed period.
    /// </summary>
    procedure SetCountCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: longint; const max: longint); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.SetCountCallbackConfiguration"/>.
    /// </summary>
    procedure GetCountCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: longint; out max: longint); virtual;

    /// <summary>
    ///  Returns *true* if the button is pressed and *false* otherwise.
    ///  
    ///  It is recommended to use the <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.OnPressed"/> and <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.OnReleased"/> callbacks
    ///  to handle the button.
    /// </summary>
    function IsPressed: boolean; virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.SetCountCallbackConfiguration"/>.
    ///  
    ///  The parameter is the same as <see cref="BrickletRotaryEncoderV2.TBrickletRotaryEncoderV2.GetCount"/>.
    /// </summary>
    property OnCount: TBrickletRotaryEncoderV2NotifyCount read countCallback write countCallback;

    /// <summary>
    ///  This callback is triggered when the button is pressed.
    /// </summary>
    property OnPressed: TBrickletRotaryEncoderV2NotifyPressed read pressedCallback write pressedCallback;

    /// <summary>
    ///  This callback is triggered when the button is released.
    /// </summary>
    property OnReleased: TBrickletRotaryEncoderV2NotifyReleased read releasedCallback write releasedCallback;
  end;

implementation

constructor TBrickletRotaryEncoderV2.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_ROTARY_ENCODER_V2_DEVICE_IDENTIFIER, BRICKLET_ROTARY_ENCODER_V2_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 1;

  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_COUNT_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_COUNT_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_IS_PRESSED] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_ROTARY_ENCODER_V2_CALLBACK_COUNT] := {$ifdef FPC}@{$endif}CallbackWrapperCount;
  callbackWrappers[BRICKLET_ROTARY_ENCODER_V2_CALLBACK_PRESSED] := {$ifdef FPC}@{$endif}CallbackWrapperPressed;
  callbackWrappers[BRICKLET_ROTARY_ENCODER_V2_CALLBACK_RELEASED] := {$ifdef FPC}@{$endif}CallbackWrapperReleased;

  (ipcon as TIPConnection).AddDevice(self);
end;

function TBrickletRotaryEncoderV2.GetCount(const reset: boolean): longint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_COUNT, 9);
  LEConvertBooleanTo(reset, 8, request);
  response := SendRequest(request, 12);
  result := LEConvertInt32From(8, response);
end;

procedure TBrickletRotaryEncoderV2.SetCountCallbackConfiguration(const period: longword; const valueHasToChange: boolean; const option: char; const min: longint; const max: longint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_COUNT_CALLBACK_CONFIGURATION, 22);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  LEConvertCharTo(option, 13, request);
  LEConvertInt32To(min, 14, request);
  LEConvertInt32To(max, 18, request);
  SendRequest(request, 0);
end;

procedure TBrickletRotaryEncoderV2.GetCountCallbackConfiguration(out period: longword; out valueHasToChange: boolean; out option: char; out min: longint; out max: longint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_COUNT_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 22);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
  option := LEConvertCharFrom(13, response);
  min := LEConvertInt32From(14, response);
  max := LEConvertInt32From(18, response);
end;

function TBrickletRotaryEncoderV2.IsPressed: boolean;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_IS_PRESSED, 8);
  response := SendRequest(request, 9);
  result := LEConvertBooleanFrom(8, response);
end;

procedure TBrickletRotaryEncoderV2.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletRotaryEncoderV2.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRotaryEncoderV2.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRotaryEncoderV2.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRotaryEncoderV2.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletRotaryEncoderV2.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRotaryEncoderV2.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletRotaryEncoderV2.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletRotaryEncoderV2.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletRotaryEncoderV2.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletRotaryEncoderV2.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletRotaryEncoderV2.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ROTARY_ENCODER_V2_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletRotaryEncoderV2.CallbackWrapperCount(const packet: TByteArray);
var count: longint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  count := LEConvertInt32From(8, packet);
  if (Assigned(countCallback)) then begin
    countCallback(self, count);
  end;
end;

procedure TBrickletRotaryEncoderV2.CallbackWrapperPressed(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(pressedCallback)) then begin
    pressedCallback(self);
  end;
end;

procedure TBrickletRotaryEncoderV2.CallbackWrapperReleased(const packet: TByteArray);
begin
  if (Length(packet) <> 8) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  if (Assigned(releasedCallback)) then begin
    releasedCallback(self);
  end;
end;

end.
